
/*
 * This file was generated by the SOM Compiler.
 * FileName: ..\..\pentkt\h\idrgest.h.
 * Generated using:
 *     SOM Precompiler somipc: 2.7
 *     SOM Emitter emith: 2.22
 */

/*
 * 
 *    CLASS: IDRGesture
 * 
 *    CLASS HIERARCHY:
 * 
 *      SOMObject
 *        IDRReco
 *              IDRGesture
 * 
 *    DESCRIPTION:
 * 
 *      Transformation of input data to gestures.
 */


#ifndef SOM_IDRGesture_h
#define SOM_IDRGesture_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef IDRGesture
#define IDRGesture SOMObject
#endif
#include <idrreco.h>

/*
 * Start of user-defined types:
 */
#ifndef SOMClass
    #define SOMClass SOMObject
#endif /* SOMClass */
#ifndef SOMObject
    #define SOMObject SOMObject
#endif /* SOMObject */
#ifndef M_IDRReco
    #define M_IDRReco SOMObject
#endif /* M_IDRReco */
#ifndef IDOStroke
    #define IDOStroke SOMObject
#endif /* IDOStroke */
#ifndef M_IDRGesture
    #define M_IDRGesture SOMObject
#endif /* M_IDRGesture */

/*
 * End of user-defined types.
 */

/*
 * Passthru lines: File: "C.h", "after"
 */


#pragma pack(2)

/*
**  Structure for gesture results.  If the symbol's type is
**  "IDR_TYPE_SYSGESTURE" the symbol's value is the virtual id.  If the
**  type is "IDR_TYPE_LETTERGESTURE" the value is the character.
*/

typedef struct _IDR_GESTRSLT    /* Gesture result descriptor */
{
  ULONG         ulSSize;        /* IDR_GESTRSLT size */
  IDR_SYM       Symbol;         /* Interpret symbol value based on type. */
  RECOID        EventId;        /* Event id; 1->N, 0 == unrecognized */
  HRECO         hRecoSubSystem; /* Reco subsystem handle */
  ULONG         ulResolution;   /* Bounding-box & hot spot(s) resolution */
  RECTL         rclBoundBox;    /* Correlated strokes surrounding box */
  POINTL        ptlHotPt;       /* Gesture x-y "hot spot" */
}   IDR_GESTRSLT,
   *PIDR_GESTRSLT,
  **PPIDR_GESTRSLT;


/*
**  Gesture information structure, i.e. information on the mapping of a
**  gesture to other PenPM system constructs.  Like the gesture result,
**  if the symbol's type is "IDR_TYPE_SYSGESTURE" the symbol's value is
**  the virtual id.  If the type is "IDR_TYPE_LETTERGESTURE" the value is
**  the character.
*/

typedef struct _IDR_GESTINFO    /* Gesture Information structure */
{
  ULONG         ulSSize;        /* IDR_GESTINFO size */
  CHAR          szGestName[MAX_RECO_NAME_LENGTH+1];  /* Name of the gesture. */
  IDR_SYM       Symbol;         /* Interpret symbol value based on type. */
  RECOID        EventId;        /* PenPM Event id */
}   IDR_GESTINFO,
   *PIDR_GESTINFO,
  **PPIDR_GESTINFO;

#pragma pack()



#define IDRGesture_MajorVersion 0
#define IDRGesture_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define IDRGestureNewClass c
#pragma linkage(c, system)
#define IDRGestureClassData d
#define IDRGestureCClassData x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <idrgest.h>
/*--------------Migration------------*/
#define IDRGesture_classObj IDRGestureClassData.classObject
#define _IDRGesture IDRGesture_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK IDRGestureNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(IDRGestureNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct IDRGestureClassDataStructure {
	SOMAny *classObject;
	somMToken idrGetGesturesInfo;
	somMToken idrRecoStrokes;
	somMToken idrIRecoStrokes;
	somMToken idrXfrmRawStrokes;
	somMToken idrTestRawAsUserGest;
	somMToken idrSetDoodleObj;
	somMToken idrGetDoodleObj;
	somMToken idrSetTextObj;
	somMToken idrGetTextObj;
	somMToken idrSetGestMap;
	somMToken idrSetSubsysRegVal;
	somMToken idrGetGestMap;
	somMToken idrGetSubsysRegVal;
} IDRGestureClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct IDRGestureCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} IDRGestureCClassData;

/*
 * New and Renew macros for IDRGesture
 */
#define IDRGestureNew() \
	( IDRGestureClassData.classObject \
		? (_somNew(IDRGestureClassData.classObject)) \
		: ( IDRGestureNewClass(IDRGesture_MajorVersion, IDRGesture_MinorVersion), (_somNew(IDRGestureClassData.classObject)) ) )
#define IDRGestureRenew(buf) \
	( _somRenew(IDRGestureClassData.classObject, buf) )

/*
 * Override method: somInit
 */
#define IDRGesture_somInit(somSelf) \
	SOMObject_somInit(somSelf)

/*
 * Override method: somUninit
 */
#define IDRGesture_somUninit(somSelf) \
	SOMObject_somUninit(somSelf)

/*
 * Override method: idrGetSymbolSubsetInfo
 */
#define IDRGesture_idrGetSymbolSubsetInfo(somSelf,ev,ulSymSets,pulSymCnt,pSyms) \
	IDRReco_idrGetSymbolSubsetInfo(somSelf,ev,ulSymSets,pulSymCnt,pSyms)

/*
 * Override method: idrGetSymbolSubset
 */
#define IDRGesture_idrGetSymbolSubset(somSelf,ev,pSymSet,pulSize) \
	IDRReco_idrGetSymbolSubset(somSelf,ev,pSymSet,pulSize)

/*
 * Override method: idrSetSymbolSubset
 */
#define IDRGesture_idrSetSymbolSubset(somSelf,ev,pSymSet) \
	IDRReco_idrSetSymbolSubset(somSelf,ev,pSymSet)

/*
 * Override method: idrAddStroke
 */
#define IDRGesture_idrAddStroke(somSelf,ev,pData,hRelative) \
	IDRReco_idrAddStroke(somSelf,ev,pData,hRelative)

/*
 * Override method: idrAddStrokefromStrokeObject
 */
#define IDRGesture_idrAddStrokefromStrokeObject(somSelf,ev,pStrokeObj) \
	IDRReco_idrAddStrokefromStrokeObject(somSelf,ev,pStrokeObj)

/*
 * New Method: idrGetGesturesInfo
 */
typedef void   SOMLINK somTP_IDRGesture_idrGetGesturesInfo(IDRGesture *somSelf, Environment *ev,
		PULONG pulGestCnt,
		PIDR_GESTINFO pInfo);
#pragma linkage(somTP_IDRGesture_idrGetGesturesInfo, system)
typedef somTP_IDRGesture_idrGetGesturesInfo *somTD_IDRGesture_idrGetGesturesInfo;
#define somMD_IDRGesture_idrGetGesturesInfo "::IDRGesture::idrGetGesturesInfo"
#define IDRGesture_idrGetGesturesInfo(somSelf,ev,pulGestCnt,pInfo) \
    (SOM_Resolve(somSelf, IDRGesture, idrGetGesturesInfo) \
	(somSelf,ev,pulGestCnt,pInfo))
#ifndef SOMGD_idrGetGesturesInfo
    #if (defined(_idrGetGesturesInfo) || defined(__idrGetGesturesInfo))
        #undef _idrGetGesturesInfo
        #undef __idrGetGesturesInfo
        #define SOMGD_idrGetGesturesInfo 1
    #else
        #define _idrGetGesturesInfo IDRGesture_idrGetGesturesInfo
    #endif /* _idrGetGesturesInfo */
#endif /* SOMGD_idrGetGesturesInfo */

/*
 * New Method: idrRecoStrokes
 */
typedef void   SOMLINK somTP_IDRGesture_idrRecoStrokes(IDRGesture *somSelf, Environment *ev,
		PRECODATA* pprdb);
#pragma linkage(somTP_IDRGesture_idrRecoStrokes, system)
typedef somTP_IDRGesture_idrRecoStrokes *somTD_IDRGesture_idrRecoStrokes;
#define somMD_IDRGesture_idrRecoStrokes "::IDRGesture::idrRecoStrokes"
#define IDRGesture_idrRecoStrokes(somSelf,ev,pprdb) \
    (SOM_Resolve(somSelf, IDRGesture, idrRecoStrokes) \
	(somSelf,ev,pprdb))
#ifndef SOMGD_idrRecoStrokes
    #if (defined(_idrRecoStrokes) || defined(__idrRecoStrokes))
        #undef _idrRecoStrokes
        #undef __idrRecoStrokes
        #define SOMGD_idrRecoStrokes 1
    #else
        #define _idrRecoStrokes IDRGesture_idrRecoStrokes
    #endif /* _idrRecoStrokes */
#endif /* SOMGD_idrRecoStrokes */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define IDRGesture_idrGetDescriptionFromFile IDRReco_idrGetDescriptionFromFile
#define IDRGesture_idrSetMetrics IDRReco_idrSetMetrics
#define IDRGesture_idrGetMetrics IDRReco_idrGetMetrics
#define IDRGesture_idrClearStrokes IDRReco_idrClearStrokes
#define IDRGesture_somFree SOMObject_somFree
#define IDRGesture_somDefaultInit SOMObject_somDefaultInit
#define IDRGesture_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define IDRGesture_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define IDRGesture_somDestruct SOMObject_somDestruct
#define IDRGesture_somDefaultAssign SOMObject_somDefaultAssign
#define IDRGesture_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define IDRGesture_somGetClass SOMObject_somGetClass
#define IDRGesture_somGetClassName SOMObject_somGetClassName
#define IDRGesture_somGetSize SOMObject_somGetSize
#define IDRGesture_somIsA SOMObject_somIsA
#define IDRGesture_somIsInstanceOf SOMObject_somIsInstanceOf
#define IDRGesture_somRespondsTo SOMObject_somRespondsTo
#define IDRGesture_somDispatchV SOMObject_somDispatchV
#define IDRGesture_somDispatchL SOMObject_somDispatchL
#define IDRGesture_somDispatchA SOMObject_somDispatchA
#define IDRGesture_somDispatchD SOMObject_somDispatchD
#define IDRGesture_somDispatch SOMObject_somDispatch
#define IDRGesture_somClassDispatch SOMObject_somClassDispatch
#define IDRGesture_somCastObj SOMObject_somCastObj
#define IDRGesture_somResetObj SOMObject_somResetObj
#define IDRGesture_somPrintSelf SOMObject_somPrintSelf
#define IDRGesture_somDumpSelf SOMObject_somDumpSelf
#define IDRGesture_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_IDRGesture_h */

#ifndef SOM_M_IDRGesture_h
#define SOM_M_IDRGesture_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_IDRGesture
#define M_IDRGesture SOMObject
#endif
#include <idrreco.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define M_IDRGesture_MajorVersion 0
#define M_IDRGesture_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_IDRGestureNewClass c
#pragma linkage(c, system)
#define M_IDRGestureClassData d
#define M_IDRGestureCClassData x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_IDRGesture_classObj M_IDRGestureClassData.classObject
#define _M_IDRGesture M_IDRGesture_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_IDRGestureNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_IDRGestureNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_IDRGestureClassDataStructure {
	SOMAny *classObject;
	somMToken idrclsNewIDRGesture;
	somMToken idrclsGetVocabulary;
	somMToken idrclsRegisterVocabulary;
} M_IDRGestureClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_IDRGestureCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} M_IDRGestureCClassData;

/*
 * New and Renew macros for M_IDRGesture
 */
#define M_IDRGestureNew() \
	( M_IDRGestureClassData.classObject \
		? (_somNew(M_IDRGestureClassData.classObject)) \
		: ( M_IDRGestureNewClass(M_IDRGesture_MajorVersion, M_IDRGesture_MinorVersion), (_somNew(M_IDRGestureClassData.classObject)) ) )
#define M_IDRGestureRenew(buf) \
	( _somRenew(M_IDRGestureClassData.classObject, buf) )

/*
 * Override method: idrclsFreeIDR
 */
#define M_IDRGesture_idrclsFreeIDR(somSelf,ev,pObject) \
	M_IDRReco_idrclsFreeIDR(somSelf,ev,pObject)

/*
 * Override method: somInit
 */
#define M_IDRGesture_somInit(somSelf) \
	SOMObject_somInit(somSelf)

/*
 * New Method: idrclsNewIDRGesture
 */
typedef IDRGesture*   SOMLINK somTP_M_IDRGesture_idrclsNewIDRGesture(M_IDRGesture *somSelf, Environment *ev,
		PVOID pCfg,
		PVOID pszRegName);
#pragma linkage(somTP_M_IDRGesture_idrclsNewIDRGesture, system)
typedef somTP_M_IDRGesture_idrclsNewIDRGesture *somTD_M_IDRGesture_idrclsNewIDRGesture;
#define somMD_M_IDRGesture_idrclsNewIDRGesture "::M_IDRGesture::idrclsNewIDRGesture"
#define M_IDRGesture_idrclsNewIDRGesture(somSelf,ev,pCfg,pszRegName) \
    (SOM_Resolve(somSelf, M_IDRGesture, idrclsNewIDRGesture) \
	(somSelf,ev,pCfg,pszRegName))
#ifndef SOMGD_idrclsNewIDRGesture
    #if (defined(_idrclsNewIDRGesture) || defined(__idrclsNewIDRGesture))
        #undef _idrclsNewIDRGesture
        #undef __idrclsNewIDRGesture
        #define SOMGD_idrclsNewIDRGesture 1
    #else
        #define _idrclsNewIDRGesture M_IDRGesture_idrclsNewIDRGesture
    #endif /* _idrclsNewIDRGesture */
#endif /* SOMGD_idrclsNewIDRGesture */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_IDRGesture_idrclsGetEngineDescription M_IDRReco_idrclsGetEngineDescription
#define M_IDRGesture_idrclsNewIDRReco M_IDRReco_idrclsNewIDRReco
#define M_IDRGesture_somUninit SOMObject_somUninit
#define M_IDRGesture__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_IDRGesture__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_IDRGesture_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_IDRGesture_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_IDRGesture_somGetInstanceAssignmentMask SOMClass_somGetInstanceAssignmentMask
#define M_IDRGesture_somGetInitMaskOffset SOMClass_somGetInitMaskOffset
#define M_IDRGesture_somGetDestructionMaskOffset SOMClass_somGetDestructionMaskOffset
#define M_IDRGesture_somAllocate SOMClass_somAllocate
#define M_IDRGesture_somDeallocate SOMClass_somDeallocate
#define M_IDRGesture_somNew SOMClass_somNew
#define M_IDRGesture_somNewNoInit SOMClass_somNewNoInit
#define M_IDRGesture_somRenew SOMClass_somRenew
#define M_IDRGesture_somRenewNoInit SOMClass_somRenewNoInit
#define M_IDRGesture_somRenewNoZero SOMClass_somRenewNoZero
#define M_IDRGesture_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_IDRGesture_somInitClass SOMClass_somInitClass
#define M_IDRGesture_somInitMIClass SOMClass_somInitMIClass
#define M_IDRGesture_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_IDRGesture_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_IDRGesture_somClassReady SOMClass_somClassReady
#define M_IDRGesture_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_IDRGesture_somGetApplyStub SOMClass_somGetApplyStub
#define M_IDRGesture_somGetClassData SOMClass_somGetClassData
#define M_IDRGesture_somSetClassData SOMClass_somSetClassData
#define M_IDRGesture__get_somCClassData SOMClass__get_somCClassData
#define M_IDRGesture__set_somCClassData SOMClass__set_somCClassData
#define M_IDRGesture_somGetClassMtab SOMClass_somGetClassMtab
#define M_IDRGesture_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_IDRGesture_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_IDRGesture_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_IDRGesture__get_somDataAlignment SOMClass__get_somDataAlignment
#define M_IDRGesture_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_IDRGesture_somGetMemberToken SOMClass_somGetMemberToken
#define M_IDRGesture_somGetMethodData SOMClass_somGetMethodData
#define M_IDRGesture_somGetRdStub SOMClass_somGetRdStub
#define M_IDRGesture_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_IDRGesture_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_IDRGesture_somGetMethodOffset SOMClass_somGetMethodOffset
#define M_IDRGesture_somGetMethodToken SOMClass_somGetMethodToken
#define M_IDRGesture_somGetName SOMClass_somGetName
#define M_IDRGesture_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_IDRGesture_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_IDRGesture_somGetNumMethods SOMClass_somGetNumMethods
#define M_IDRGesture_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_IDRGesture_somGetParent SOMClass_somGetParent
#define M_IDRGesture_somGetParents SOMClass_somGetParents
#define M_IDRGesture_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_IDRGesture_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_IDRGesture_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_IDRGesture_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_IDRGesture_somCheckVersion SOMClass_somCheckVersion
#define M_IDRGesture_somDescendedFrom SOMClass_somDescendedFrom
#define M_IDRGesture_somSupportsMethod SOMClass_somSupportsMethod
#define M_IDRGesture_somGetClassDataEntry SOMClass_somGetClassDataEntry
#define M_IDRGesture_somSetClassDataEntry SOMClass_somSetClassDataEntry
#define M_IDRGesture_somDefinedMethod SOMClass_somDefinedMethod
#define M_IDRGesture_somCastObjCls SOMClass_somCastObjCls
#define M_IDRGesture_somResetObjCls SOMClass_somResetObjCls
#define M_IDRGesture__get_somTrueClass SOMClass__get_somTrueClass
#define M_IDRGesture__get_somCastedClass SOMClass__get_somCastedClass
#define M_IDRGesture_somCloneClass SOMClass_somCloneClass
#define M_IDRGesture_somFindMethod SOMClass_somFindMethod
#define M_IDRGesture_somFindMethodOk SOMClass_somFindMethodOk
#define M_IDRGesture_somFindSMethod SOMClass_somFindSMethod
#define M_IDRGesture_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_IDRGesture_somLookupMethod SOMClass_somLookupMethod
#define M_IDRGesture_somOverrideMtab SOMClass_somOverrideMtab
#define M_IDRGesture__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_IDRGesture__get_somMethodOffsets SOMClass__get_somMethodOffsets
#define M_IDRGesture_somUninit SOMObject_somUninit
#define M_IDRGesture_somDumpSelfInt SOMObject_somDumpSelfInt
#define M_IDRGesture_somPrintSelf SOMObject_somPrintSelf
#define M_IDRGesture_somFree SOMObject_somFree
#define M_IDRGesture_somDefaultInit SOMObject_somDefaultInit
#define M_IDRGesture_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define M_IDRGesture_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define M_IDRGesture_somDestruct SOMObject_somDestruct
#define M_IDRGesture_somDefaultAssign SOMObject_somDefaultAssign
#define M_IDRGesture_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define M_IDRGesture_somUninit SOMObject_somUninit
#define M_IDRGesture_somGetClass SOMObject_somGetClass
#define M_IDRGesture_somGetClassName SOMObject_somGetClassName
#define M_IDRGesture_somGetSize SOMObject_somGetSize
#define M_IDRGesture_somIsA SOMObject_somIsA
#define M_IDRGesture_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_IDRGesture_somRespondsTo SOMObject_somRespondsTo
#define M_IDRGesture_somDispatchV SOMObject_somDispatchV
#define M_IDRGesture_somDispatchL SOMObject_somDispatchL
#define M_IDRGesture_somDispatchA SOMObject_somDispatchA
#define M_IDRGesture_somDispatchD SOMObject_somDispatchD
#define M_IDRGesture_somDispatch SOMObject_somDispatch
#define M_IDRGesture_somClassDispatch SOMObject_somClassDispatch
#define M_IDRGesture_somCastObj SOMObject_somCastObj
#define M_IDRGesture_somResetObj SOMObject_somResetObj
#define M_IDRGesture_somPrintSelf SOMObject_somPrintSelf
#define M_IDRGesture_somDumpSelf SOMObject_somDumpSelf
#define M_IDRGesture_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_IDRGesture_h */
